/* Apple Macintosh PowerPC systems running MacOS-X (Rhapsody and Darwin) */

#include <lcc-conf.h>

#include <string.h>

static char rcsid[] = "$Id: macosx.c,v 1.5 2001/03/21 13:56:04 beebe Exp beebe $";

#ifndef LOCALDIR
#define LOCALDIR	"/usr/local/"
#endif

#ifndef GCCDIR
#define GCCDIR LOCALDIR "lib/gcc-lib/ppc-redhat-linux/2.95.2/"
#endif

#ifndef LCCDIR
#define LCCDIR LOCALDIR "lib/lcc/"
#endif

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", 0 };

char inputs[256] = "";

char *cpp[] = { LCCDIR "cpp",
	"-U__GNUC__", "-D_POSIX_SOURCE", "-D__STDC__=1", "-D__STRICT_ANSI__",
	/* Match the following -Dxxx=yyy values to what gcc -v reports! */
	"-DPPC",
	"-D_ARCH_PPC",
	"-D_BIG_ENDIAN",
	"-D_CALL_SYSV",
	"-D__BIG_ENDIAN__",
	"-D__ELF__",
	"-D__PPC",
	"-D__PPC__",
	"-D__linux__",
	"-D__powerpc",
	"-D__powerpc__",
	"-D__unix__",
	"-Dlinux",
	"-Dpowerpc",
	"-Dunix",
	/* "-Acpu(powerpc)", */
	/* "-Amachine(bigendian)", */
	/* "-Amachine(powerpc)", */
	/* "-Asystem(posix)", */
	/* "-Asystem(unix)", */
	/* "-D__CHAR_UNSIGNED__", */	/* lcc has signed chars by default */
	/* "-D__GNUC_MINOR__=95", */
	/* "-D__GNUC__=2", */
	"$1", "$2", "$3", 0 };

char *include[] = {
	"-I" LCCDIR "include",
	"-I" LOCALDIR "include",
	"-I" GCCDIR "include",
	"-I" GCCDIR "../../../../ppc-redhat-linux/include",
	"-I/usr/include",
	0 };

char *com[] = {LCCDIR "rcc", "-target=sparc/linux", "$1", "$2", "$3", 0 };

char *as[] = { "/usr/bin/as", "-o", "$3", "$1", "$2", 0 };

char *ld[] = {
	/* 0 */ "/usr/bin/ld",
		"-arch",
		"ppc",
		"-dynamic",
	/* 4 */ "-lcrt1.o",
		"-o",
		"$3",
		"-lcc_dynamic",
	/* 8 */	"-framework",
		"System",
		"/usr/bin/objcunique",
		"$1",
	/* 12*/	"$2",
		"-L" LCCDIR,
		"-L" LOCALDIR "lib ",
		"-llcc",
	/* 16*/	"",
		"-lm",
		"-lcc_dynamic",
		"",
	/* 20*/	"",
		0
	};

extern char *concat(char *, char *);

int option(char *arg) {
  	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		ld[13] =  concat("-L", &arg[8]);
		com[0] = concat(&arg[8], "/rcc");
	} else if (strncmp(arg, "-as=", 4) == 0) {
		as[0] = concat(&arg[4], "");
	} else if (strncmp(arg, "-cpp=", 5) == 0) {
		cpp[0] = concat(&arg[5], "");
	} else if (strncmp(arg, "-ld=", 4) == 0) {
		ld[0] = concat(&arg[4],"");
	} else if (strncmp(arg, "-rcc=", 5) == 0) {
		com[0] = concat(&arg[5],"");
	} else if (strcmp(arg, "-p") == 0 || strcmp(arg, "-pg") == 0) {
		ld[4] = "-lgcrt1.o";
		ld[9] = "System,_profile";
	} else if (strcmp(arg, "-b") == 0)
		;
	else if (strcmp(arg, "-g") == 0)
		;
	else if (strcmp(arg, "-dynamic") == 0)
	        ;			/* default */
	else if (strcmp(arg, "-static") == 0) {
	        ld[3] = "-static";
	        ld[18] = "-lcc";
	} else
		return 0;
	return 1;
}
