/* Sun SPARC systems running Linux */

#include <lcc-conf.h>

#include <string.h>

static char rcsid[] = "$Id: linux.c,v 1.6 2001/03/28 13:16:13 beebe Exp beebe $";

#ifndef LOCALDIR
#define LOCALDIR	"/usr/local/"
#endif

#ifndef GCCDIR
#define GCCDIR LOCALDIR "lib/gcc-lib/sparc-unknown-linux-gnu/2.95.2/"
#endif

#ifndef LCCDIR
#define LCCDIR LOCALDIR "lib/lcc/"
#endif

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", 0 };
char inputs[256] = "";
char *cpp[] = { LCCDIR "cpp",
	"-U__GNUC__", "-D_POSIX_SOURCE", "-D__STDC__=1", "-D__STRICT_ANSI__",
	/* Match the following -Dxxx=yyy values to what gcc -v reports! */
	"-D__ELF__",
	"-D__linux",
	"-D__linux__",
	"-D__sparc__",
	"-D__unix",
	"-D__unix__",
	"-Dlinux",
	"-Dunix", 
	"$1", "$2", "$3", 0 };
char *include[] = {"-I" LCCDIR "include", "-I/usr/include", "-I/usr/sparc-glibc20-linux/include", "-I" GCCDIR "include", "-I" LOCALDIR "include", 0 };
char *com[] = {LCCDIR "rcc", "-target=sparc/linux", "$1", "$2", "$3", 0 };
#if 0
char *as[] = { "/usr/bin/as", "-o", "$3", "$1", "$2", 0 };
#else
char *as[] = { LCCDIR "fixas", "-o", "$3", "$1", "$2", 0 };
#endif
char *ld[] = {
	/*  0 */ "/usr/bin/ld", "-m", "elf32_sparc", "-dynamic-linker",
	/*  4 */ "/lib/ld-linux.so.2", "-o", "$3",
	/*  7 */ "/usr/lib/crt1.o", "/usr/lib/crti.o", GCCDIR "crtbegin.o", "$1", "$2",
	/* 12 */ "-L" LCCDIR,
	/* 13 */ "-L" LOCALDIR "lib -llcc",
	/* 14 */ "", "", "-lc", "-lm",
	/* 18 */ "", 
		 GCCDIR "crtend.o", 
		 "/usr/lib/crtn.o",
	0 };

extern char *concat(char *, char *);

int option(char *arg) {
  	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		ld[12] =  concat("-L", &arg[8]);
		com[0] = concat(&arg[8], "/rcc");
	} else if (strncmp(arg, "-as=", 4) == 0) {
		as[0] = concat(&arg[4], "");
	} else if (strncmp(arg, "-cpp=", 5) == 0) {
		cpp[0] = concat(&arg[5], "");
	} else if (strncmp(arg, "-ld=", 4) == 0) {
		ld[0] = concat(&arg[4],"");
	} else if (strncmp(arg, "-rcc=", 5) == 0) {
		com[0] = concat(&arg[5],"");
	} else if (strcmp(arg, "-p") == 0 || strcmp(arg, "-pg") == 0) {
		ld[7] = "/usr/lib/gcrt1.o";
		ld[18] = "-lgmon";
	} else if (strcmp(arg, "-b") == 0) 
		;
	else if (strcmp(arg, "-g") == 0)
		;
	else if (strcmp(arg, "-dynamic") == 0)
	        ;			/* default */
	else if (strcmp(arg, "-static") == 0) {
	        ld[3] = "-static";
	        ld[4] = "";
	        ld[14] = "-L" GCCDIR;
	        ld[15] = "-lgcc";
	} else
		return 0;
	return 1;
}
