/* SPARCs running Solaris 2.5.1 at CS Dept., Princeton University */

#include <lcc-conf.h>

#include <string.h>

static char rcsid[] = "$Id: solaris.c,v 1.8 2001/04/06 23:34:47 beebe Exp beebe $";

#ifndef LOCALDIR
#define LOCALDIR "/usr/local/"
#endif

#ifndef LCCDIR
#define LCCDIR LOCALDIR "lib/lcc/"
#endif

#ifndef NATIVEDIR
#define NATIVEDIR "/opt/SUNWspro/WS6U1/lib/"
#endif

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", 0 };
char inputs[256] = "";
char *cpp[] = { LCCDIR "cpp",
	"-D__STDC__=1", "-Dsparc", "-D__sparc__", "-Dsun", "-D__sun__", "-Dunix",
	"$1", "$2", "$3", 0 };
char *include[] = { "-I" LCCDIR "include", "-I/usr/local/include",
	"-I/usr/include", 0 };
char *com[] = { LCCDIR "rcc", "-target=sparc/solaris",
	"$1", "$2", "$3", 0 };
char *as[] = { "/usr/ccs/bin/as", "-Qy", "-s", "-o", "$3", "$1", "$2", 0 };
char *ld[] = {
	/* 0 */	"/usr/ccs/bin/ld",
		"-o",
		"$3",
		"$1",
	/* 4 */	NATIVEDIR "crti.o",
		NATIVEDIR "crt1.o",
		VALUESOBJ,
		"-Bdynamic",
	/* 8 */	"$2",
		"",
		"-Y",
		"P," NATIVEDIR ":/usr/ccs/lib:/usr/lib",
	/* 12*/	"-Qy",
		"-L" LOCALDIR,
		"-L" LCCDIR,
		"-llcc",
	/* 16*/	"-lm",
		"-lc",
		NATIVEDIR "crtn.o",
		 0 };

extern char *concat(char *, char *);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		ld[14] = concat("-L", &arg[8]);
		com[0] = concat(&arg[8], "/rcc");
	} else if (strncmp(arg, "-as=", 4) == 0) {
		as[0] = concat(&arg[4], "");
	} else if (strncmp(arg, "-cpp=", 5) == 0) {
		cpp[0] = concat(&arg[5], "");
	} else if (strncmp(arg, "-ld=", 4) == 0) {
		ld[0] = concat(&arg[4],"");
	} else if (strncmp(arg, "-rcc=", 5) == 0) {
		com[0] = concat(&arg[5],"");
	} else if (strcmp(arg, "-g") == 0)
		;
	else if ((strcmp(arg, "-p") == 0) || (strcmp(arg, "-pg") == 0)) { /* -p == -pg on Solaris 2.x */
		ld[5] = NATIVEDIR "mcrt1.o";
		ld[11] = ("P," NATIVEDIR "libp:/usr/ccs/lib/libp:/usr/lib/libp:"
			 NATIVEDIR ":/usr/ccs/lib:/usr/lib");
	} else if (strcmp(arg, "-b") == 0)
		;
	else if (strcmp(arg, "-dynamic") == 0)
	        ld[7] = "-Bdynamic";
	else if (strcmp(arg, "-static") == 0)
	        ld[7] = "-Bstatic";
	else
		return 0;
	return 1;
}
