#! /bin/sh
# Test lcc with wchar_t data type.
# [21-Mar-2001]

LIBDIR=`dirname $0`
trap '/bin/rm -f wchar.o a.out'

echo ========================================================================
echo Requesting -wchar_t=unsigned_char
/bin/rm -f a.out &&
	 lcc -Wf-wchar_t=unsigned_char $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo Requesting -wchar_t=unsigned_char
/bin/rm -f a.out &&
	 lcc -Wf-wchar_t=unsigned_short $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo Requesting -wchar_t=unsigned_int
/bin/rm -f a.out &&
	 lcc -Wf-wchar_t=unsigned_int $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo Testing native cc wchar_t
/bin/rm -f a.out &&
	 cc $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo Testing native c89 wchar_t
/bin/rm -f a.out &&
	 c89 $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo Testing GNU gcc wchar_t
/bin/rm -f a.out &&
	 gcc $LIBDIR/wchar.c &&
	 ./a.out &&
	 /bin/rm -f a.out
echo ------------------------------------------------------------------------
echo ========================================================================
